;=== DEFiNE
!define REG    `${SET}\${APP}.reg`
!define DEFREG `${DEFSET}\${APP}.reg`
;===
!define SEC    `Software\EasyBoot Systems\UltraISO\5.0`
!define LANG   `HKEY_CURRENT_USER\${SEC}`
!define KEY    Language
;===
!define CLS    `SOFTWARE\Classes`
!define ISODRV `SYSTEM\CurrentControlSet\services\ISODrive`
!define CLSID  `${CLS}\CLSID\{AD392E40-428C-459F-961E-9B147782D099}\InprocServer32`
!define DRV    `${APPDIR}\drivers`
!define BAK    `${DRV}.bak`
!define ISO    `${DRV}\IsoCmd.exe`
!define EJECT  `"${ISO}" -eject $R0`
!define DEV0   `"${ISO}" -number 0`
!define DEV1   `"${ISO}" -number 1`
;===
!define DOC    `${DATA}\My ISO Files`
;===
!define RMDIR1 `$TEMP\Ultra$$ISO`
;===
!define EZB    `${APPDIR}\EZB Systems`
!define EXE    `${APPDIR}\UltraISO.exe`
!define SENDTO `$SENDTO\${APP}.lnk`
;===
!define PFM    `$0\PortableApps.com\PortableAppsPlatform.exe`
;===
Function GetLCID
	!macro _GetLCID _LNG _LCID
		Push ${_LNG}
		Call GetLCID
		Pop ${_LCID}
	!macroend
	!define GetLCID `!insertmacro _GetLCID`
	Exch $0
	StrCmp $0 1059 END
	StrCmp $0 1046 END
	StrCmp $0 1026 END
	StrCmp $0 1027 END
	StrCmp $0 2052 END
	StrCmp $0 1028 END
	StrCmp $0 1050 END
	StrCmp $0 1029 END
	StrCmp $0 1030 END
	StrCmp $0 1031 END
	StrCmp $0 1033 END
	StrCmp $0 1034 END
	StrCmp $0 1061 END
	StrCmp $0 1035 END
	StrCmp $0 1036 END
	StrCmp $0 1032 END
	StrCmp $0 1037 END
	StrCmp $0 1038 END
	StrCmp $0 1057 END
	StrCmp $0 1040 END
	StrCmp $0 1041 END
	StrCmp $0 1042 END
	StrCmp $0 1062 END
	StrCmp $0 1257 END
	StrCmp $0 1071 END
	StrCmp $0 1086 END
	StrCmp $0 1043 END
	StrCmp $0 1044 END
	StrCmp $0 1065 END
	StrCmp $0 1045 END
	StrCmp $0 2070 END
	StrCmp $0 1048 END
	StrCmp $0 1049 END
	StrCmp $0 2074 END
	StrCmp $0 1051 END
	StrCmp $0 1060 END
	StrCmp $0 1053 END
	StrCmp $0 1055 END
	StrCmp $0 1058 END
	StrCmp $0 1066 END
	StrCmp $0 10241 0 +3
	StrCpy $0 1025
		Goto END
	StrCmp $0 2075 0 +3
	StrCpy $0 3098
		Goto +2
	StrCpy $0 1033
	END:
	Exch $0
FunctionEnd
Function GetLNG
	!macro _GetLNG _LCID _LNG
		Push ${_LCID}
		Call GetLNG
		Pop ${_LNG}
	!macroend
	!define GetLNG `!insertmacro _GetLNG`
	Exch $0
	StrCmp $0 1025 0 +3
	StrCpy $0 10241
		Goto +3
	StrCmp $0 3098 0 +2
	StrCpy $0 2075
	Exch $0
FunctionEnd
Function validateLCID
	!macro _validateLCID _LCID _RETURN
		Push ${_LCID}
		Call validateLCID
		Pop ${_RETURN}
	!macroend
	!define validateLCID `!insertmacro _validateLCID`
	Exch $0
	StrCmp $0 1059 END
	StrCmp $0 1046 END
	StrCmp $0 1026 END
	StrCmp $0 1027 END
	StrCmp $0 2052 END
	StrCmp $0 1028 END
	StrCmp $0 1050 END
	StrCmp $0 1029 END
	StrCmp $0 1030 END
	StrCmp $0 1031 END
	StrCmp $0 1033 END
	StrCmp $0 1034 END
	StrCmp $0 1061 END
	StrCmp $0 1035 END
	StrCmp $0 1036 END
	StrCmp $0 1032 END
	StrCmp $0 1037 END
	StrCmp $0 1038 END
	StrCmp $0 1057 END
	StrCmp $0 1040 END
	StrCmp $0 1041 END
	StrCmp $0 1042 END
	StrCmp $0 1062 END
	StrCmp $0 1257 END
	StrCmp $0 1071 END
	StrCmp $0 1086 END
	StrCmp $0 1043 END
	StrCmp $0 1044 END
	StrCmp $0 1065 END
	StrCmp $0 1045 END
	StrCmp $0 2070 END
	StrCmp $0 1048 END
	StrCmp $0 1049 END
	StrCmp $0 2074 END
	StrCmp $0 1051 END
	StrCmp $0 1060 END
	StrCmp $0 1053 END
	StrCmp $0 1055 END
	StrCmp $0 1058 END
	StrCmp $0 1066 END
	StrCmp $0 1025 END
	StrCmp $0 3098 END
	StrCpy $0 error
	END:
	Exch $0
FunctionEnd
!define DEFSAVE `!insertmacro _DEFSAVE`
!macro _DEFSAVE _FILE _ENTRY _SEC _VALUE
	ClearErrors
	${ConfigReads} `${_FILE}` `"${_ENTRY}"="` $0
	IfErrors +2
	StrCmp $0 `"` 0 +2
	WriteRegStr HKCU `${_SEC}` ${_ENTRY} `${_VALUE}`
!macroend
Function CAPTURE
	${If} $9 == ""
		StrCpy $0 StopGetDrives
	${Else}
		${WriteRuntimeData} ${PAL} $9 1
	${EndIf}
	Push $0
FunctionEnd
Function DISMOUNT
	${If} $9 == ""
		StrCpy $0 StopGetDrives
	${Else}
		ClearErrors
		${ReadRuntimeData} $R0 ${PAL} $9
		${If} ${Errors}
			StrCpy $R0 $9 2
			nsExec::ExecToStack `${EJECT}`
			Return
		${EndIf}
	${EndIf}
	Push $0
FunctionEnd
;=== CUSTOM
${SegmentFile}
${Segment.OnInit}
	Push $0
	${IsWOW64} $0
	StrCmp $0 0 +3
	${WriteSettings} 64 Architecture
		Goto +2
	${WriteSettings} 32 Architecture
	Pop $0
!macroend
;===
!macro ProExecInit
	StrCpy $ProgramExecutable `${APP}\${APP}.exe`
!macroend
;===
!macro InstanceManagement
	StrCmp $0 0 +2
	Quit
!macroend
;===
!define MsgBox "!insertmacro MsgBox"
!macro MsgBox
	StrCpy $0 `Windows XP +`
	MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
	Call Unload
	Quit
!macroend
!macro OS
	Push $0
	${If} ${IsNT}
		${If} ${IsWinXP}
			${IfNot} ${AtLeastServicePack} 2
				StrCpy $0 `Service Pack 2 +`
				MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
				Call Unload
				Quit
			${EndIf}
		${ElseIfNot} ${AtLeastWinXP}
			${MsgBox}
		${EndIf}
	${Else}
		${MsgBox}
	${EndIf}
	Pop $0
!macroend
;===
!define PortableApps.comLocaleID "!insertmacro PortableApps.comLocaleID"
!macro PortableApps.comLocaleID
	IfFileExists `${REG}` 0 +3
	ReadINIStr $0 `${REG}` `${LANG}` `"${KEY}"`
		Goto +2
	ReadINIStr $0 `${DEFREG}` `${LANG}` `"${KEY}"`
	${GetLCID} $0 $0
	${SetEnvironmentVariable} PortableApps.comLocaleID $0
!macroend
!macro Lang
	Push $0
	${GetParent} $EXEDIR $0
	${If} ${FileExists} `${PFM}`
		ReadEnvStr $0 PortableApps.comLocaleID
		${validateLCID} $0 $0
		${If} $0 == error
			${PortableApps.comLocaleID}
		${EndIf}
	${Else}
		${PortableApps.comLocaleID}
	${EndIf}
	Pop $0
!macroend
;===
!macro LangInit
	Push $0
	ReadEnvStr $0 PortableApps.comLocaleID
	${GetLNG} $0 $0
	${SetEnvironmentVariable} PAL:LanguageCustom $0
	Pop $0
!macroend
;===
!macro Init
	IfFileExists `${DOC}` +2
	CreateDirectory `${DOC}`
	IfFileExists `${REG}` +2
	CopyFiles /SILENT `${DEFREG}` `${REG}`
!macroend
;===
!macro EnvironmentVariables
	Push $0
	${If} ${RunningX64}
		${SetEnvironmentVariable} DLL isoshl64.dll
		${SetEnvironmentVariable} ISODrive ISODrv64.sys
	${Else}
		${SetEnvironmentVariable} DLL isoshell.dll
		${SetEnvironmentVariable} ISODrive ISODrive.sys
	${EndIf}
	ClearErrors
	${ReadSettings} $0 LastSysDir
	IfErrors +2
	StrCmp $0 "" 0 +2
	StrCpy $0 $SYSDIR
	${SetEnvironmentVariablesPath} LastSysDir $0
	Pop $0
!macroend
;===
!macro RunAsAdminOverride
	${If} $SecondaryLaunch != true
	${AndIf} ${ProcessExists} UltraISO.exe
		Quit
	${EndIf}
!macroend
!macro RunAsAdmin
	Push $0
	${ConfigReads} `${CONFIG}` Administrator= $0
	${If} $0 == true
		StrCpy $RunAsAdmin force
		Rename `${BAK}` `${DRV}`
	${ElseIf} $0 == auto
		${If} ${IsAdmin}
			StrCpy $RunAsAdmin force
			Rename `${BAK}` `${DRV}`
		${Else}
			Rename `${DRV}` `${BAK}`
		${EndIf}
	${Else}
		Rename `${DRV}` `${BAK}`
	${EndIf}
	Pop $0
!macroend
;===
!macro PreRegWrite
	${If} $RunAsAdmin == force
		WriteRegStr HKCU `${SEC}` ShellExt 1
		WriteRegStr HKLM `${SEC}` Install 1
		WriteRegStr HKLM `${SEC}` ShellExt 1
		WriteRegStr HKLM `${SEC}` "" `${APPDIR}`
		WriteRegStr HKLM `${SEC}` Shared `${EZB}`
		WriteRegStr HKLM `${CLS}\.bin` "" binimage
		WriteRegStr HKLM `${CLS}\.iso` "" UltraISO
		WriteRegStr HKLM `${CLS}\.isz` "" UltraISO
		WriteRegStr HKLM `${CLS}\.ui` "" UltraISO
		WriteRegStr HKLM `${CLS}\UltraISO\DefaultIcon` "" `"${EXE}",0`
		WriteRegStr HKLM `${CLS}\UltraISO\shell\open\command` "" `"${EXE}" "%1"`
		WriteRegStr HKLM `${CLS}\UltraISO\shellex\ContextMenuHandlers\ISOShell` "" {AD392E40-428C-459F-961E-9B147782D099}
		WriteRegStr HKLM `${CLS}\binimage\DefaultIcon` "" `"${EXE}",0`
		WriteRegStr HKLM `${CLS}\binimage\shell\Convert to ISO\command` "" `"${EXE}" -bin2iso "%1"`
		WriteRegStr HKLM `${CLS}\binimage\shell\open\command` "" `"${EXE}" "%1"`
		WriteRegStr HKLM `${CLS}\binimage\shellex\ContextMenuHandlers\ISOShell` "" {AD392E40-428C-459F-961E-9B147782D099}
		WriteRegStr HKLM `${CLS}\Directory\shellex\ContextMenuHandlers\UltraISO` "" {AD392E40-428C-459F-961E-9B147782D099}
		WriteRegStr HKLM `${CLS}\Drive\shellex\ContextMenuHandlers\UltraISO` "" {AD392E40-428C-459F-961E-9B147782D099}
		WriteRegStr HKLM `${CLS}\Folder\ShellEx\ContextMenuHandlers\UltraISO` "" {AD392E40-428C-459F-961E-9B147782D099}
	${Else}
		WriteRegStr HKLM `${SEC}` ShellExt 0
		WriteRegStr HKCU `${SEC}` ShellExt 0
		WriteRegStr HKCU `${SEC}` "" `${APPDIR}`
		WriteRegStr HKCU `${SEC}` Shared `${EZB}`
		WriteRegStr HKCU `${CLS}\.bin` "" binimage
		WriteRegStr HKCU `${CLS}\.iso` "" UltraISO
		WriteRegStr HKCU `${CLS}\.isz` "" UltraISO
		WriteRegStr HKCU `${CLS}\.ui` "" UltraISO
		WriteRegStr HKCU `${CLS}\UltraISO\DefaultIcon` "" `"${EXE}",0`
		WriteRegStr HKCU `${CLS}\UltraISO\shell\open\command` "" `"${EXE}" "%1"`
		WriteRegStr HKCU `${CLS}\binimage\DefaultIcon` "" `"${EXE}",0`
		WriteRegStr HKCU `${CLS}\binimage\shell\Convert to ISO\command` "" `"${EXE}" -bin2iso "%1"`
		WriteRegStr HKCU `${CLS}\binimage\shell\open\command` "" `"${EXE}" "%1"`
	${EndIf}
!macroend
;===
${SegmentPrePrimary}
	${If} $RunAsAdmin == force
		${GetDrives} ALL CAPTURE
	${EndIf}
	${File::BackupLocal} `${SENDTO}`
	CreateShortCut `${SENDTO}` `${EXE}` "" `${EXE}` 0
	${WriteSettings} `$SYSDIR` LastSysDir
	${SetEnvironmentVariablesPath} SYSDIR $SYSDIR
!macroend
;===
${SegmentPreExecPrimary}
	Push $0
	${If} $RunAsAdmin == force
		nsExec::ExecToStack `${DEV1}`
	${EndIf}
	${DEFSAVE} `${REG}` ISOFolder `${SEC}` `${DOC}`
	${DEFSAVE} `${REG}` OpenFolder `${SEC}` `${DOC}`
	${DEFSAVE} `${REG}` SaveFolder `${SEC}` `${DOC}`
	Pop $0
!macroend
;=== DLL
!macro PreDLL
	${If} $RunAsAdmin == force
		Push $0
		${If} ${RunningX64}
			SetRegView 64
			ClearErrors
			ReadRegStr $0 HKLM `${CLSID}` ""
			${IfNot} ${Errors}
				${WriteRuntimeData} ${PAL} DLL `$0`
				${DLL::UNREG} `$0` /DISABLEFSR
			${EndIf}
			SetRegView LastUsed
		${Else}
			ClearErrors
			ReadRegStr $0 HKLM `${CLSID}` ""
			${IfNot} ${Errors}
				${WriteRuntimeData} ${PAL} DLL `$0`
				${DLL::UNREG} `$0` ""
			${EndIf}
		${EndIf}
		Pop $0
	${EndIf}
!macroend
!macro PrePrimaryDLL
	${If} $RunAsAdmin == force
		Push $0
		ReadEnvStr $0 DLL
		CopyFiles /SILENT `${DRV}\$0` `$TEMP`
		${DLL::REG} `$TEMP\$0` /DISABLEFSR
		Pop $0
	${EndIf}
!macroend
!macro PostPrimaryDLL
	${If} $RunAsAdmin == force
		Push $0
		ReadEnvStr $0 DLL
		${DLL::UNREG} `$TEMP\$0` /DISABLEFSR
		Pop $0
	${EndIf}
!macroend
!macro UnloadDLL
	${If} $RunAsAdmin == force
		Push $0
		ClearErrors
		${ReadRuntimeData} $0 ${PAL} DLL
		${IfNot} ${Errors}
			${DLL::REG} `$0` /DISABLEFSR
		${EndIf}
		Pop $0
	${EndIF}
!macroend
;=== SERViCES
!macro PreServices
	${If} $RunAsAdmin == force
		Push $0
		Push $1
		ClearErrors
		ReadRegStr $0 HKLM `${ISODRV}` ImagePath
		${IfNot} ${Errors}
			StrCpy $1 $0 4
			StrCmp $1 \??\ 0 +2
			StrCpy $0 $0 "" 4
			${WriteRuntimeData} ${PAL} ISODrive `$0`
			ReadRegStr $0 HKLM `${ISODRV}` Start
			${WriteRuntimeData} ${PAL} ISODriveStart $0
			${SC::Stop} ISODrive /DISABLEFSR
			${SC::Delete} ISODrive /DISABLEFSR
		${EndIf}
		Pop $1
		Pop $0
	${EndIf}
!macroend
!macro PrePrimaryServices
	${If} $RunAsAdmin == force
		Push $0
		ReadEnvStr $0 ISODrive
		${SC::Create} ISODrive `${DRV}\$0` filesys system "" /DISABLEFSR
		${SC::Start} ISODrive /DISABLEFSR
		Pop $0
	${EndIf}
!macroend
!macro PostPrimaryServices
	${If} $RunAsAdmin == force
		Push $0
		${GetDrives} ALL DISMOUNT
		ClearErrors
		${ReadRuntimeData} $0 ${PAL} ISODrive
		${If} ${Errors}
			nsExec::ExecToStack `${DEV0}`
			${SC::Stop} ISODrive /DISABLEFSR
			${SC::Delete} ISODrive /DISABLEFSR
		${Else}
			${SC::Stop} ISODrive /DISABLEFSR
		${EndIf}
		Pop $0
	${EndIf}
!macroend
!macro UnloadServices
	${If} $RunAsAdmin == force
		Push $0
		ClearErrors
		${ReadRuntimeData} $0 ${PAL} ISODrive
		${IfNot} ${Errors}
			${SC::Create} ISODrive `$0` filesys system "" /DISABLEFSR
			${ReadRuntimeData} $0 ${PAL} ISODriveStart
			${If} $0 != 4
				${SC::Start} ISODrive /DISABLEFSR
			${EndIf}
		${EndIf}
		Pop $0
	${EndIf}
!macroend
;=== UNLOAD
${SegmentUnload}
	Push $0
	RMDir /r `${RMDIR1}`
	${File::RestoreLocal} `${SENDTO}`
	${If} $RunAsAdmin == force
		${ConfigReads} `${CONFIG}` DeleteDLLByForce= $0
		${If} $0 == true
			${Close} `${CABW}` ""
		${EndIf}
	${EndIf}
	ReadEnvStr $0 DLL
	Delete /REBOOTOK `$TEMP\$0`
	Pop $0
!macroend